'use strict';

module.exports = function createAddParentProcessor() {
	let currentLevel = 0;
	let lastKnownNodes = [];

	return {
		onEnter: function onEnter(node) {
			if (currentLevel > 0) {
				node._parent = lastKnownNodes[currentLevel - 1];
			}

			lastKnownNodes[currentLevel] = node;
			currentLevel += 1;
		},
		onExit: function onExit() {
			currentLevel -= 1;
		}
	};
};
